## Script (Python) "apply_pume"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=REQUEST
##title=
##
# $Id: apply_pume.py 2102 2007-08-16 11:45:27Z joachim $
"""
process the Pume Application Form
"""
try:
    from Products.zdb import set_trace
except:
    def set_trace():
        pass

import DateTime
current = DateTime.DateTime()
pr = context.portal_registration
request = REQUEST

#type_name = 'StudentApplication'
#ti = context.portal_types[type_name]
#REQUEST.set('type_name',type_name)
create = "create" in request.keys()
apply_pume = "apply" in request.keys()
edit = "edit" in request.keys()
submitted = False
mode = request.get('mode','')
if not mode:
    if apply_pume or edit:
        mode = "edit"
    else:
        mode = "create"
validate = create or edit or apply_pume

lt = context.portal_layouts
reg_no = request.get('widget__reg_no','').upper()
if not reg_no:
    reg_no = request.form.get('reg_no','').upper()
pin = request.form.get('pin','')
object = {}
if reg_no:
    brains = context.applicants_catalog(reg_no = reg_no)
    if len(brains) == 1:
        for field in context.applicants_catalog.schema():
            object[field] = getattr(brains[0],field,None)
        if object['status'] == "submitted":
            submitted = True
        #set_trace()
        if not create and pin != object['pin']:
            return request.RESPONSE.redirect("%s/srp_anonymous_view" % context.portal_url())

res,psm,ds = lt.renderLayout(layout_id= 'application',
                             schema_id= 'application',
                             layout_mode = mode,
                             context=context,
                             mapping=validate and REQUEST,
                             ob=object,
                             commit = False,
                            )

set_trace()
if psm == 'invalid':
    return context.apply_pume_form(rendered = res,
                                   psm = "Please correct your input!",
                                   #psm = "%s, %s" % (psm,ds),
                                   mode = mode,
                                   ds = ds,
                                  )
elif psm == '':
    return context.apply_pume_form(rendered = res,
                                   psm = None,
                                   ds = ds,
                                   mode = mode,
                                  )
elif psm == 'valid':
    pass
data = {}
for field in context.applicants_catalog.schema():
    if ds.has_key(field) and request.has_key("widget__%s" % field):
        data[field] = ds.get(field)
data['reg_no'] = reg_no
if apply_pume:
    data['registration_date'] = current
    data['status'] = "submitted"
context.applicants_catalog.modifyRecord(**data)
if apply_pume:
    if not request.has_key('confirm'):
        mode = "edit"
        psm = "Please confirm Passport Photograph"
    else:
        mode = "view"
        psm = "You successfully applied for PUME"
elif create:
    if submitted:
        mode = "view"
    else:
        mode = "edit"
    psm = ""
    #set_trace()
    object['pin'] = str(ds.get('pin'))
    res,psm,dummy = lt.renderLayout(layout_id= 'application',
                                schema_id= 'application',
                                layout_mode = mode,
                                context=context,
                                mapping={},
                                ob=object,
                                commit = False,
                                )
elif edit:
    mode = "edit"
    psm = "Content changed"

return context.apply_pume_form(rendered = res,
                            psm = psm,
                            #psm = "%s, %s" % (psm,ds),
                            mode = mode,
                            ds = ds,
                            )


